<?php
/*
Plugin Name: TGN Embed everything
Plugin URI: http://www.thewpwiki.com/extensions/tgn-embed-everything
Description: Easily embed YouTube, PDF, Google docs, spreadsheets, PowerPoint, Word, VideoReadr, TIFF and more into WordPress 3! For example: [youtube X8gBdsBjpJw 604 364]

Author: George Vanous <george@thewpwiki.com>
Version: 1.0.13
Author URI: http://www.thewpwiki.com/
*/

/*
BUGS
  WordPress adds &nbsp; sometimes which breaks the shortcodes
  eg [form&nbsp;dE1pUWxwQUJXY21uZlUzSnpMYzhNZ0E6MQ] // in HTML view

TODO
  Add [map (address)] eg [map 8930 watson court delta bc v4c8a1]
  Read directly into WordPress like http://www.blackspike.com/site/html/display-google-docs-spreadsheets-in-wordpress
  Howto edit a google spreadsheet with others in realtime using wave: http://www.google.com/support/forum/p/wave/thread?tid=6b6e582d4e66a39f&hl=en
  Support Google Forms like http://www3.formassembly.com/blog/using-google-spreadsheet-as-a-reporting-tool-for-formassembly/
  To share a spreadsheet, click Share > Publish as a web page > select the sheet to publish > click Start publishing > click on All cells field > insert the cells range, e.g. A2:A3 > click Republish now > copy the link > Close
*/

define('tgn_ee_defaultWidth', '604');
define('tgn_ee_shortHeight', '302');
define('tgn_ee_defaultHeight', '604');
define('tgn_ee_defaultVideoReadrHeight', '560');
define('tgn_ee_defaultYouTubeHeight', '364');
define('tgn_ee_fullWidth', '100%');


function tgn_ee_linkify_url_and_email_addresses($text)
{
	$text = ' ' . $text;

	// in testing, using arrays here was found to be faster
	$text =
		preg_replace
		(
			array
			(
				'#([\s>])([\w]+?://[\w\#$%&~/.\-;:=,?@\[\]+]*)#is',
				'#([\s>])((www|ftp)\.[\w\#$%&~/.\-;:=,?@\[\]+]*)#is',
				'#([\s>])([-\w.]+)@([-\w.]+\w)#i'
//			'#([\s>])([a-z0-9\-_.]+)@([^,< \n\r]+)#i'
			),

			array
			(
				'$1<a href="$2">$2</a>',
				'$1<a href="http://$2">$2</a>',
				'$1<a href="mailto:$2@$3">$2@$3</a>'
			),

			$text
		);

		// this one is not in an array because we need it to run last, for cleanup of accidental links within links
		$text = preg_replace("#(<a( [^>]+?>|>))<a [^>]+?>([^>]+?)</a></a>#i", "$1$3</a>", $text);

		return trim($text);
}

add_filter('the_content', 'tgn_ee_linkify_url_and_email_addresses');


function tgn_ee_head()
{
	// videoreadr temporary patch to size videos to their correct height
	echo <<<EOS
<script type="text/javascript">
window.$ || ($ = jQuery); // useful for extensions that use $ instead of jQuery
</script>

<style type="text/css">
.layout_transcript2 .l_left { height:371px !important }
.layout_transcript2 .l_transcript { top:371px !important }
</style>
EOS;
}

add_action('wp_head', 'tgn_ee_head');


function tgn_ee_ckfinder_shortcode($values)
{
	extract(tgn_ee_parse_shortcode_height_first(0, array(
		'width' => tgn_ee_fullWidth,
		'height' => tgn_ee_defaultHeight,
	), $values));

	return tgn_ee_ckfinder_script($width, $height);
}

add_shortcode('ckfinder', 'tgn_ee_ckfinder_shortcode');


function tgn_ee_form_shortcode($values)
{
	extract(tgn_ee_parse_shortcode_height_first(1, array(
		'key' => '',
		'width' => tgn_ee_fullWidth,
		'height' => tgn_ee_defaultHeight,
	), $values));

	return tgn_ee_google_docs_form_iframe($key, $width, $height);
}

add_shortcode('form', 'tgn_ee_form_shortcode');


function tgn_ee_machform_shortcode($values)
{
	extract(tgn_ee_parse_shortcode_height_first(1, array(
		'key' => '',
		'width' => tgn_ee_fullWidth,
		'height' => tgn_ee_defaultHeight,
	), $values));

	return tgn_ee_machform_iframe($key, $width, $height);
}

add_shortcode('machform', 'tgn_ee_machform_shortcode');


function tgn_ee_pdf_shortcode($values)
{
	extract(tgn_ee_parse_shortcode_height_first(1, array(
		'file' => 'http://tgnbooks.com/the-great-gatsby.pdf',
		'width' => tgn_ee_fullWidth,
		'height' => tgn_ee_defaultHeight,
	), $values));

	return tgn_ee_google_docs_viewer_iframe($file, $width, $height);
}

add_shortcode('pdf', 'tgn_ee_pdf_shortcode');


function tgn_ee_powerpoint_shortcode($values)
{
	extract(tgn_ee_parse_shortcode_height_first(1, array(
		'file' => '',
		'width' => tgn_ee_fullWidth,
		'height' => tgn_ee_defaultHeight,
	), $values));

	return tgn_ee_google_docs_viewer_iframe($file, $width, $height);
}

add_shortcode('powerpoint', 'tgn_ee_powerpoint_shortcode');


function tgn_ee_show_shortcode($values)
{
	extract(tgn_ee_parse_shortcode_height_first(1, array(
		'file' => 'http://tgnbooks.com/the-great-gatsby.pdf',
		'width' => tgn_ee_fullWidth,
		'height' => tgn_ee_defaultHeight,
	), $values));

	return tgn_ee_google_docs_viewer_iframe($file, $width, $height);
}

add_shortcode('show', 'tgn_ee_show_shortcode');


function tgn_ee_spreadsheet_shortcode($values)
{
	extract(tgn_ee_parse_shortcode_height_first(1, array(
		'key' => '0AtFXq8XyejTEdGNEZm1NZUJ3V3QwXzIwZnQ1ckh0MlE',
		'width' => tgn_ee_fullWidth,
		'height' => tgn_ee_defaultHeight,
		'view' => 'minimum',
		'authkey' => '',
	), $values));

	return tgn_ee_google_spreadsheet_viewer_iframe($key, $width, $height, $view, $authkey);
}

add_shortcode('spreadsheet', 'tgn_ee_spreadsheet_shortcode');


function tgn_ee_tiff_shortcode($values)
{
	extract(tgn_ee_parse_shortcode_height_first(1, array(
		'file' => '',
		'width' => tgn_ee_fullWidth,
		'height' => tgn_ee_defaultHeight,
	), $values));

	return tgn_ee_google_docs_viewer_iframe($file, $width, $height);
}

add_shortcode('tiff', 'tgn_ee_tiff_shortcode');


function tgn_ee_videoreadr_shortcode($values)
{
	extract(tgn_ee_parse_shortcode(array(
		'key' => 'I1uezBsE',
		'width' => tgn_ee_defaultWidth,
		'height' => tgn_ee_defaultVideoReadrHeight,
		'background' => 'black',
	), $values));

	return tgn_ee_videoreadr_script($key, $width, $height, $background);
}

add_shortcode('videoreadr', 'tgn_ee_videoreadr_shortcode');


function tgn_ee_word_shortcode($values)
{
	extract(tgn_ee_parse_shortcode_height_first(1, array(
		'file' => '',
		'width' => tgn_ee_fullWidth,
		'height' => tgn_ee_defaultHeight,
	), $values));

	return tgn_ee_google_docs_viewer_iframe($file, $width, $height);
}

add_shortcode('word', 'tgn_ee_word_shortcode');


function tgn_ee_youtube_shortcode($values)
{
//return('<pre>' . print_r($values, true) . ' - ' . print_r(tgn_ee_parse_shortcode(array('key' => 'X8gBdsBjpJw', 'width' => '604', 'height' => '364'), $values), true) . '</pre>');

	extract(tgn_ee_parse_shortcode(array(
		'key' => 'X8gBdsBjpJw',
		'width' => tgn_ee_defaultWidth,
		'height' => tgn_ee_defaultYouTubeHeight,
	), $values));

	return tgn_ee_youtube_iframe($key, $width, $height);
}

add_shortcode('youtube', 'tgn_ee_youtube_shortcode');


//==============================================================================
// CKFinder
// ckfinder.com
// File manager, functional free demo (demo notice, cannot drag-and-drop files), $59 per-domain license, $590 per-company license
//

function tgn_ee_ckfinder_script($width, $height)
{
	$siteUrl = get_option('siteurl');

  return <<<EOS
<div id="ckfinder"></div>

<script type="text/javascript" src="$siteUrl/wp-content/plugins/ckeditor-for-wordpress/ckfinder/ckfinder.js"></script>
<script type="text/javascript">

(function()
{
	var config = {};

	// Always use 100% width and height when nested using this middle page.
	config.width = '$width';
	config.height = '$height';

	var ckfinder = new CKFinder(config);
	ckfinder.replace('ckfinder', config);
})();

</script>
EOS;
}

function tgn_ee_ckfinder_iframe($width, $height)
{
	$siteUrl = get_option('siteurl');

	return <<<EOS
<iframe src="$siteUrl/wp-content/plugins/ckeditor-for-wordpress/ckfinder/ckfinder.html" width="$width" height="$height" marginheight="0" marginwidth="0" frameborder="0"></iframe>
EOS;
}


//==============================================================================
// Google docs viewer
// http://docs.google.com/viewer
// Supports doc, pdf, ppt, tiff (no Flash or PDF browser plugins required)
// Also supports some docx, pptx (only way to know is to test yours and see if it displays)

function tgn_ee_google_docs_viewer_iframe($url, $width, $height)
{
	$url = urlEncode($url);

	return <<<EOS
<iframe src="http://docs.google.com/viewer?url=$url&embedded=true" width="$width" height="$height" marginwidth="0" marginheight="0" frameborder="0"></iframe>
EOS;
}


//==============================================================================
// Google docs form
// http://docs.google.com/
// Create > Form

function tgn_ee_google_docs_form_iframe($key, $width, $height)
{
	return <<<EOS
<iframe src="http://spreadsheets.google.com/embeddedform?formkey=$key" width="$width" height="$height" frameborder="0" marginheight="0" marginwidth="0">Loading...</iframe>
EOS;
}


//==============================================================================
// Google spreadsheet viewer
// http://spreadsheets.google.com/
// Supports doc, pdf, ppt, tiff (no Flash or PDF browser plugins required)
// Also supports some docx, pptx (only way to know is to test yours and see if it displays)
//
function tgn_ee_google_spreadsheet_viewer_iframe($keyOrUrl, $width, $height, $view, $authkey)
{
	$key = tgn_ee_extractKey_google_spreadsheet($keyOrUrl);

	if ('normal' == $view)
	{
		$range = '';
	}
	else if ('edit' == $view)
	{
		return <<<EOS
<iframe src="http://spreadsheets.google.com/ccc?key=$key&authkey=$authkey" width="$width" height="$height" marginwidth="0" marginheight="0" frameborder="0"></iframe>
EOS;
	}
	else
	{
		if ('minimum' == $view)
		{
			$view = 'A1:Z100';
		}

		$range = '&range=' . $view;
	}

	return <<<EOS
<iframe src="http://spreadsheets.google.com/pub?key=$key&single=true$range&output=html" width="$width" height="$height" marginwidth="0" marginheight="0" frameborder="0"></iframe>
EOS;
}

// Google Chrome pastes links as <a> tags, eg: <a href="http://spreadsheets.google.com/pub?key=0AtFXq8XyejTEdGNEZm1NZUJ3V3QwXzIwZnQ1ckh0MlE&amp;hl=en&amp;output=html">http://spreadsheets.google.com/pub?key=0AtFXq8XyejTEdGNEZm1NZUJ3V3QwXzIwZnQ1ckh0MlE&amp;hl=en&amp;output=html</a>
function tgn_ee_extractKey_google_spreadsheet($keyOrUrl)
{
	preg_match('@(?:\bkey=)([-\w]+)|([-\w]+)$@', $keyOrUrl, $matches);
	return $matches[ count($matches) - 1 ];
}

/*
function tgn_ee_extractKey_authKey_google_spreadsheet($keyOrUrl, &$key, &$authkey)
{
	if (false !== strpos($keyOrUrl, '?'))
	{
		preg_match('@(?:\bkey=)([-\w]+)|([-\w]+)$@', $keyOrUrl, $matches);

		return $matches[ count($matches) - 1 ];
	}

	return $keyOrUrl
}
*/


//==============================================================================
// Machform
// appnitro.com
// PHP HTML form builder
//

function tgn_ee_machform_iframe($key, $width, $height)
{
	$siteUrl = get_option('siteurl');

  return <<<EOS
<iframe width="$width" height="$height" marginwidth="0" marginheight="0" frameborder="0" scrolling="no" allowTransparency="true" style="border:none" src="$siteUrl/machform/embed.php?id=$key"></iframe>
EOS;
}

function tgn_ee_machform_php($key, $width, $height)
{
	require 'machform/machform.php';
	$mf_param['form_id'] = (integer)$key;
	$mf_param['base_path'] = 'http://otc699318.fromanywhere.com/beta-1/';
	display_machform($mf_param);
}


//==============================================================================
// YouTube
// youtube.com
// Broadcast yourself
//

function tgn_ee_youtube_iframe($keyOrUrl, $width, $height)
{
  $key = tgn_ee_extractKey_youtube($keyOrUrl);

  return <<<EOS
<iframe width="$width" height="$height" src="http://www.youtube.com/embed/$key" type="text/html" frameborder="0" marginwidth="0" marginheight="0"></iframe>
EOS;
}

function tgn_ee_youtube_object($keyOrUrl, $width, $height)
{
  $key = tgn_ee_extractKey_youtube($keyOrUrl);

  return <<<EOS
<object width="$width" height="$height">
	<param name="movie" value="http://www.youtube.com/v/$key?fs=1&amp;hl=en_US"></param>
	<param name="allowFullScreen" value="true"></param>
	<param name="allowscriptaccess" value="always"></param>
	<embed src="http://www.youtube.com/v/$key?fs=1&amp;hl=en_US" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="$width" height="$height"></embed>
</object>
EOS;
}

function tgn_ee_extractKey_youtube($keyOrUrl)
{
	preg_match('@(?:\?v=|/v/)([-\w]+)|([-\w]+)$@', $keyOrUrl, $matches);
	return $matches[ count($matches) - 1 ];

//	$values = parse_url( $url, PHP_URL_QUERY );
//	parse_str($values);

//	if (isSet($v))
//	{
//		return $v;
//	}

//	return 'not found';
}

//function tgn_ee_extractKey_youtube_test()
//{
// jzNmX69h_HA
// http://www.youtube.com/watch?v=jzNmX69h_HA
// http://www.youtube.com/watch?v=jzNmX69h_HA&feature=player_embedded
// http://www.youtube.com/v/jzNmX69h_HA?fs=1&amp;hl=en_US
// http://www.youtube.com/tgnDragonAge2#p/u/0/jzNmX69h_HA
// http://www.youtube.com/tgnWorldOfWarcraft#p/c/FD3ACB6A1128406A/3/ZXKobFJWuyc
//
//	$s = 'jzNmX69h_HA';
//	echo tgn_ee_extractKey_youtube($s);
//	echo '<br><br>';
//
//	$s = 'http://www.youtube.com/watch?v=jzNmX69h_HA';
//	echo tgn_ee_extractKey_youtube($s);
//	echo '<br><br>';
//
//	$s = 'http://www.youtube.com/watch?v=jzNmX69h_HA&feature=player_embedded';
//	echo tgn_ee_extractKey_youtube($s);
//	echo '<br><br>';
//
//	$s = 'http://www.youtube.com/v/jzNmX69h_HA?fs=1&amp;hl=en_US';
//	echo tgn_ee_extractKey_youtube($s);
//	echo '<br><br>';
//
//	$s = 'http://www.youtube.com/user/tgnDragonAge2#p/u/0/jzNmX69h_HA';
//	echo tgn_ee_extractKey_youtube($s);
//	echo '<br><br>';
//
//	$s = 'http://www.youtube.com/tgnWorldOfWarcraft#p/c/FD3ACB6A1128406A/3/ZXKobFJWuyc';
//	echo tgn_ee_extractKey_youtube($s);
//	echo '<br><br>';
//}


//==============================================================================
// VideoReadr
// videoreadr.com
// Enhance YouTube videos with bookmarks and transcripts
//
function tgn_ee_videoreadr_script($key, $width, $height, $background)
{
	$background_urlEncoded = str_replace('#', '%23', $background);

  return <<<EOS
<script src="http://videoreadr.com/read/$key.js?embed=true&width=$width&height=$height&background=$background_urlEncoded&layout=transcript2" type="text/javascript"></script>
EOS;
}

function tgn_ee_videoreadr_iframe($key, $width, $height, $background)
{
	$background_urlEncoded = str_replace('#', '%23', $background);

  return <<<EOS
<iframe src="http://videoreadr.com/read/$key?embed=true&width=$width&height=$height&background=$background_urlEncoded&layout=transcript2" width="$width" height="$height" marginwidth="0" marginheight="0" frameborder="0"></iframe>
EOS;
}


//==============================================================================
// Utility
// Helper functions
//

//
// Swap width and height if only one given
// * [pdf tgnbooks.com/the-great-gatsby.pdf 400] // assumes height:400
// * [pdf tgnbooks.com/the-great-gatsby.pdf 600 400] // assumes width:600 height:400
//
function tgn_ee_parse_shortcode_height_first($widthIndex, $defaults, $values)
{
	if (is_array($values) && isSet($values[$widthIndex]) && !isSet($values[$widthIndex + 1]))
	{
		$newDefaults = array();
		$i = 0;

		foreach ($defaults as $key => $value)
		{
			if ($i == $widthIndex) // found the width
			{
				$widthKey = $key;
				$widthValue = $value;
			}
			else
			{
				$newDefaults[$key] = $value;

				if ($i == $widthIndex + 1) // found the height
				{
					$newDefaults[$widthKey] = $widthValue; // swap width and height positions
				}
			}

			$i++;
		}

		return tgn_ee_parse_shortcode($newDefaults, $values);
	}

	return tgn_ee_parse_shortcode($defaults, $values);
}

//
// [youtube]                            -> key:default,     width:default, height:default
// [youtube=X8gBdsBjpJw]                -> key:X8gBdsBjpJw, width:default, height:default (Equals (=) is optional)
// [youtube X8gBdsBjpJw]                -> key:X8gBdsBjpJw, width:default, height:default
// [youtube X8gBdsBjpJw 200]            -> key:X8gBdsBjpJw, width:200,     height:default
// [youtube X8gBdsBjpJw height=200]     -> key:X8gBdsBjpJw, width:default, height:200
// [youtube X8gBdsBjpJw height=200 300] -> (Unsupported: shorthand values must appear before key:value pairs)
//
function tgn_ee_parse_shortcode($defaults, $values)
{
	// commented: can do this in one loop, not two
//	$out = shortcode_atts($defaults, $values);

	if (is_array($values)) // if ('' === $values) // $values === '' if [shortcode] has no atributes
	{
		$out = array();
		reset($defaults);

		// process shorthand values first in $defaults order
		if (isSet($values[0]))
		{
			$key = key($defaults);
			$out[$key] = ltrim($values[0], '='); // first value may start with '=', eg: [youtube=X8gBdsBjpJw] -> values[0] = '=X8gBdsBjpJw'

			for ($i = 1; false !== next($defaults) && isSet($values[$i]); $i++)
			{
				$key = key($defaults);
				$out[$key] = $values[$i];
			}
		}

		// process key:value pairs next, continuing from shorthand values in $defaults order
		while (list($key, $value) = each($defaults))
		{
			$out[$key] = array_key_exists($key, $values) ? $values[$key] : $value;
		}
	}
	else
	{
		$out = $defaults; // creates a copy of $defaults
	}

	return $out;
}

?>
